package edu.odu.cs.zeil.AlgAE.Snapshot;

import java.awt.Color;

public class Connector {
	private EntityIdentifier source;
	private EntityIdentifier destination;
	private double minAngle;
	private double maxAngle;
	private double preferredLength;
	private double elasticity;
	private String value;
	private String label;
	private Color color;
	private String id;
	private int componentIndex;
	
	

	public Connector (String id, EntityIdentifier source, EntityIdentifier destination, double minAngle, double maxAngle)
	{
		this.source = source;
		this.destination = destination;
		this.minAngle = minAngle;
		this.maxAngle = maxAngle;
		this.id = id;
		setPreferredLength(2.0);
		setElasticity(1.0);
		color = Color.black;
		value = "";
		label = "";
		componentIndex = -1;
	}

	public Connector (String id, EntityIdentifier source, EntityIdentifier destination, double minAngle, double maxAngle, int component)
	{
		this.source = source;
		this.destination = destination;
		this.minAngle = minAngle;
		this.maxAngle = maxAngle;
		this.id = id;
		setPreferredLength(2.0);
		setElasticity(1.0);
		color = Color.black;
		value = "";
		label = "";
		componentIndex = component;
	}

	public EntityIdentifier getSource() {
		return source;
	}

	public EntityIdentifier getDestination() {
		return destination;
	}

	public void setDestination(EntityIdentifier dest) {
		destination = dest;
	}

	public double getMinAngle() {
		return minAngle;
	}

	public double getMaxAngle() {
		return maxAngle;
	}

	public void setPreferredLength(double preferredLength) {
		this.preferredLength = preferredLength;
	}

	public double getPreferredLength() {
		return preferredLength;
	}

	public void setElasticity(double elasticity) {
		this.elasticity = elasticity;
	}

	public double getElasticity() {
		return elasticity;
	}
	
	public void setColor(Color color) {
		this.color = color;
	}

	public Color getColor() {
		return color;
	}
	
	public void setValue(String value) {
		this.value = value;
	}

	public String getValue() {
		return value;
	}
	


	
	public String toString()
	{
		return source + "=>" + ((destination != null) ? destination : "0");
	}

	public void setLabel(String label) {
		this.label = label;
	}

	public String getLabel() {
		return label;
	}

	

	public String getID() {
		return id;
	}

	public int getComponentIndex() {
		return componentIndex;
	}

}
