package edu.odu.cs.zeil.AlgAE.Snapshot;

import edu.odu.cs.zeil.AlgAE.AnimationContext;
import edu.odu.cs.zeil.AlgAE.Server.Server;

public class Identifier {

	private int id;
	private static int idCount = 0;
	
	
	/**
	 * Try to find a known identifier for this object. If none is found, register
	 * a new, arbitrary identifier for the purpose.
	 *  
	 * @param c
	 * @return the unique ID for this object
	 */
	public static Identifier getIdentifierFor(Object obj, AnimationContext context) {
		Server server = context.getServer();
		return server.getIdentifierFor(obj);
	}

	public Identifier() {
		++idCount;
		id = idCount;
	}

	public static Identifier nullID = new Identifier(0);
	
	private Identifier(int forcedID) {
		id = forcedID;
	}
	
	public String toString()
	{
		return "" + id;
	}
		
	public int hashCode() {
		return id;
	}
	
	public boolean equals (Object obj) {
		if (obj == null)
			return false;
		try {
			Identifier other = (Identifier)obj;
			return id == other.id;
		} catch (Exception ex) {
			return false;
		}
	}
}
