#ifndef INDEXABLE_H
#define INDEXABLE_H

//
// Indexable is an abstract class for things that have integer-addressed
// components that another Visible item can point to.
//

class Visible;

class Indexable 
{
public:

  virtual Visible* elementAt (int index) const = 0;
  //pre: (none)
  //  v = elementAt(index)
  //post:  if index is in a valid range,  *v is the element at the 
  //            index'th position
  //       if index is outside the valid range, v == null

};


#endif
