#ifndef VISIBLE_QUEUE_H
#define VISIBLE_QUEUE_H

#include <algae/config.h>
#include <algae/visible.h>
#include <vector>




template <class T>
class VisibleQueue: public Visible
{
private:
   std::vector<T> v;
public:
  VisibleQueue(AlgAE::Color color, bool vertical)
    : Visible(color, vertical), v() {}

  VisibleQueue (const VisibleQueue& s)
    : v(s.v), Visible(s.color(), s.vertical()) {}

  ~VisibleQueue() {}

  VisibleQueue& operator=(const VisibleQueue<T>& x)
    {
     v = x.v;
     return *this;
    }


   T& front() { return v.front(); }
   const T& front() const { return v.front(); }
   T& back() { return v.back(); }
   const T& back() const { return v.back(); }

   void push (const T& x)  {v.push_back(x);}
   void pop ()             {v.erase(v.begin());}

   bool empty() const      {return v.empty();}
   unsigned size() const   {return v.size();}

   // Required for animation
   virtual void touchAllComponents() const
      {
       for (int i = v.size(); i > 0; i--)
          touch (v[i-1]);
      }

  virtual void writeText (std::ostream &) const
    {
    }
  
      
};


#endif

