#ifndef VISIBLE_STACK_H
#define VISIBLE_STACK_H

#include <vector>
#include <algae/algae.h>





template <class T>
class VisibleStack: public Visible
{
private:
   std::vector<T> v;
public:
  VisibleStack(AlgAE::Color color, bool vertical): Visible(color, vertical), v(/*color,vertical*/) {}

  VisibleStack (const VisibleStack& s) : v(s.v), Visible(s.color(), s.vertical()) {}

  ~VisibleStack() {}

  VisibleStack& operator=(const VisibleStack<T>& x)
    {
     v = x.v;
     return *this;
    }


   T& top() {return v.back();}
   const T& top() const {return v.back();}

   void push (const T& x)  {v.push_back(x);}
   void pop ()             {v.pop_back();}

   bool empty() const      {return v.empty();}
   unsigned size() const   {return v.size();}

   // Required for animation
   virtual void touchAllComponents() const
      {
       for (int i = v.size(); i > 0; i--)
          touch (v[i-1]);
      }

  virtual void touchAllPointers() const
    {
    }

  virtual void writeText(std::ostream& out) const
    {
    }

};


#endif

