package edu.odu.cs.AlgAE.Demos;//!

import edu.odu.cs.zeil.AlgAE.ActivationRecord;//!
import edu.odu.cs.zeil.AlgAE.Animation;//!
import edu.odu.cs.zeil.AlgAE.Utilities.Index;//!

public class Sorting {//!


//
//  Based on Malik, "C++ Programming [From Problem Analysis to Program Design]"
//      chapter 10
//

public static//!
	void bubbleSort(int list[], int length)
	{
    ActivationRecord arec = Animation.activate(Sorting.class);//!
    arec.breakHere("starting bubble sort").refParam("list", null).param("length", length).show();//!
	    int temp;
	    int iteration;
	    int index;

	    for (iteration = 1; iteration < length; iteration++)
	    {
	        arec.breakHere("start a pass over the array").refParam("list", null).param("length", length).var("iteration", iteration).show();//!
	        for (index = 0; index < length - iteration; index++)
	        {//!
		        arec.breakHere("compare list[index] to list[index+1]").refParam("list", null).param("length", length).var("iteration", iteration).var("index", new Index(index, list)).show();//!
	            if (list[index] > list[index + 1]) 
	            {
			        arec.breakHere("list[index] and list[index+1] are out of order - swap them").refParam("list", null).param("length", length).var("iteration", iteration).var("index", new Index(index, list)).show();//!
	                temp = list[index];
	                list[index] = list[index + 1];
	                list[index + 1] = temp;
	            }
	        }//!
	        arec.breakHere("completed this pass over the array").refParam("list", null).param("length", length).var("iteration", iteration).show();//!

	    }
	    arec.breakHere("compeleted bubble sort").refParam("list", null).param("length", length).show();//!
	}

	
public static//!
	void selectionSort(int list[], int length)
	{
    ActivationRecord arec = Animation.activate(Sorting.class);//!
    arec.breakHere("starting selection sort").refParam("list", null).param("length", length).show();//!
	    int index;
	    int smallestIndex;
	    int location;
	    int temp;

	    for (index = 0; index < length - 1; index++)
	    {
	    	arec.breakHere("Find the value to go into list[index]").refParam("list", null).param("length", length).var("index", new Index(index, list)).show();//!
	            //Step a
	        smallestIndex = index; 
	    	arec.breakHere("smallestIndex holds location of smallest remaining value found so far").refParam("list", null).param("length", length).var("index", new Index(index, list)).var("smallestIndex", new Index(smallestIndex, list)).show();//!

	        for (location = index + 1; location < length; location++)
	        {//!
		    	arec.breakHere("see if location holds a smaller value").refParam("list", null).param("length", length).var("index", new Index(index, list)).var("smallestIndex", new Index(smallestIndex, list)).var("location", new Index(location, list)).show();//!

	        	if (list[location] < list[smallestIndex])
	        	{//!
			    	arec.breakHere("Yes, it does.").refParam("list", null).param("length", length).var("index", new Index(index, list)).var("smallestIndex", new Index(smallestIndex, list)).var("location", new Index(location, list)).show();//!
	                smallestIndex = location;
			    	arec.breakHere("New value for smallestLocation.").refParam("list", null).param("length", length).var("index", new Index(index, list)).var("smallestIndex", new Index(smallestIndex, list)).var("location", new Index(location, list)).show();//!
	        	}//!
	        }//!
	            //Step b
	    	arec.breakHere("Swap the values in smallestLocation and index").refParam("list", null).param("length", length).var("index", new Index(index, list)).var("smallestIndex", new Index(smallestIndex, list)).var("location", new Index(location, list)).show();//!
	        temp = list[smallestIndex];
	        list[smallestIndex] = list[index];
	        list[index] = temp;
	    	arec.breakHere("Ready to move to the next index position").refParam("list", null).param("length", length).var("index", new Index(index, list)).var("smallestIndex", new Index(smallestIndex, list)).var("location", new Index(location, list)).show();//!
	    }
	    arec.breakHere("completed selection sort").refParam("list", null).param("length", length).show();//!
	}

	
public static//!
	void insertionSort (int list[], int listLength)
	{
	    ActivationRecord arec = Animation.activate(Sorting.class);//!
	    arec.breakHere("starting insertion sort").refParam("list", null).param("listLength", listLength).show();//!
		int firstOutOfOrder, location;
		int temp;
		
		for (firstOutOfOrder = 1; firstOutOfOrder < listLength;
		                          firstOutOfOrder++)
		{//!
			arec.breakHere("move list[firstOutOfOrder] into place").refParam("list", null).param("listLength", listLength).var("firstOutOfOrder", new Index(firstOutOfOrder, list)).show();//!
	        if (list[firstOutOfOrder] < list[firstOutOfOrder-1])
			{
				temp = list[firstOutOfOrder];
				location = firstOutOfOrder;
				arec.breakHere("temp holds the value we want to insert").refParam("list", null).param("listLength", listLength).var("firstOutOfOrder", new Index(firstOutOfOrder, list)).var("temp",temp).var("location", new Index(location, list)).show();//!
				
				do
				{
					arec.breakHere("shift an element up to make room").refParam("list", null).param("listLength", listLength).var("firstOutOfOrder", new Index(firstOutOfOrder, list)).var("temp",temp).var("location", new Index(location, list)).show();//!
					list[location] = list[location - 1];
					arec.breakHere("then move to the next lower element").refParam("list", null).param("listLength", listLength).var("firstOutOfOrder", new Index(firstOutOfOrder, list)).var("temp",temp).var("location", new Index(location, list)).show();//!
					location--;
				}
				while (location > 0 && list[location - 1] > temp);
				
				arec.breakHere("Now we know where to insert temp").refParam("list", null).param("listLength", listLength).var("firstOutOfOrder", new Index(firstOutOfOrder, list)).var("temp",temp).var("location", new Index(location, list)).show();//!
				list[location] = temp;
			}
			arec.breakHere("Move to the next unordered element").refParam("list", null).param("listLength", listLength).var("firstOutOfOrder", new Index(firstOutOfOrder, list)).show();//!
		}//!
		arec.breakHere("Completed insertion sort").refParam("list", null).param("listLength", listLength).show();//!
	}
	
        
        
}//!
